<template>
  <div id="app">
    <div class="container-fluid">
      <Form @setTableData="setTableData" @setRowPerPage="setRowPerPage"/>
      <div class="wrapper">
        <Table :tableData="tableData" :rowPerPage="rowPerPage"/>
        <Pie :pie-data="dataForPie"/>
      </div>
    </div>
  </div>
</template>

<script>
import Form from "@/components/Form"
import Table from "@/components/Table";
import Pie from "@/components/Pie";

export default {
  name: 'App',
  components: {
    Pie,
    Table,
    Form
  },
  data: () => ({
    tableData: [],
    rowPerPage: undefined,
  }),
  computed: {
    randData() {
      return this.tableData.map(({rand}) => (rand))
    },
    dataForPie() {
      const pieData = [];
      const totalItems = this.randData.length;
      const uniqueItems = [...new Set(this.randData)]
      uniqueItems.forEach(currItem => {
        const numItems = this.randData.filter(item => item === currItem)
        pieData.push({
          key: currItem,
          percent: (numItems.length * 100 / totalItems).toFixed(2),
        })
      })
      return pieData;
    }
  },
  methods: {
    setTableData(e) {
      this.tableData = e;
    },
    setRowPerPage(e) {
      this.rowPerPage = Number(e);
    }
  }
}
</script>

<style lang="scss">
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}

.wrapper {
  display: flex;
}
</style>
